#cs ----------------------------------------------------------------------------

    Copyright (C) 2006-2007 Dustin Spicuzza

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	
	This is an AutoIt script that can rename and modify an IPP printer under
	Windows either interactively or via the command line. 
	
	This is probably not the best language to implement this in, I know. But,
	it was less complicated when I first made it.. haha. 
	
#ce ----------------------------------------------------------------------------

#RequireAdmin
#include <GUIConstants.au3>

;// determine whether we're in command line mode or not


If $CmdLine[0] <> 0 Then

	If $CmdLine[0] <> 3 And $CmdLine[0] <> 2 Then
		Msgbox(0,"Invalid command line parameters!", "Usage: prnRename <old printer name> <new printer name> [new printer hostname]" & @CR & @CR & "Examples:" & @CR & "    prnRename oldPrinter1 newPrinter1" & @CR & "    prnRename oldPrinter1 newPrinter1 http://hostname/classes/printername" & @CR & @CR & "It is important to note that the old printer name must match the name in the registry at SOFTWARE\Microsoft\Windows NT\CurrentVersion\Print\Printers\[key], or match the [key] portion of that. It will NOT always match the name of the printer as shown in Control Panel, though if you used this tool before then it probably will. Test this first!" & @CR & @CR & "For obvious reasons, enclose parameters with space in quotes.")
		Exit
	EndIf
	
	;// see if the old printer exists
	$oldPrinter = GetPrinterKeyByName($CmdLine[1])
	
	If $oldPrinter = "" Then
		MsgBox(0,"Error","Printer """ & $CmdLine[1] & """ does not exist!")
		Exit
	EndIf
	
	
	If $CmdLine[0] = 2 Then
		RenamePrinter($oldPrinter, $CmdLine[2], "", 0)
	Else
		RenamePrinter($oldPrinter, $CmdLine[2], $CmdLine[3], 0)
	EndIf
	
	;// we're done now
	Exit
	
EndIf



MsgBox(0,"Warning!","This tool may cause permanent damage to your computer. Use it only to rename and modify IPP printers. I am not responsible for anything that may or may not happen, including correct results." & @CR & @CR & "(C)2006-2007 Dustin Spicuzza")

$state = 0

GuiCreate("",380,100,-1,-1)
$lbl = GUICtrlCreateLabel( "Select printer to rename", 15, 5, 350, 25)
$cb = GUICtrlCreateCombo ( "", 15, 35, 350, 15, 3)
$b1 = GUICtrlCreateButton ("Rename",  265, 65, 100)


For $i = 1 to 1000
	$var = RegEnumKey("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Print\Printers", $i)
	If @error <> 0 Then ExitLoop
	GUICtrlSetData($cb,$var)
Next

GUISetState(@SW_SHOW)

	
While 1
    $msg = GUIGetMsg()
    if $msg = $b1 Then
		Select
			case $state = 0
			
			
				$oldPrinterName = GUICtrlRead($cb)
				$oldPrinterHost = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Print\Printers\" & $oldPrinterName & "\HttpData","UIRealNetworkName")
				
				If $oldPrinterHost = "" Then
				
					MsgBox(0,"Error","You did not select a valid IPP Printer!")
				
				;// ask them for the new name for the printer
				ElseIf $oldPrinterName <> "" Then
					GUICtrlDelete($cb)
					GUICtrlSetData($lbl,"Enter new name for """ & $oldPrinterName & """")
					$cb = GUICtrlCreateInput("",15,35,350)
					
					$state = 1
				EndIf
				
			case $state = 1
			
				$newPrinterName = GUICtrlRead($cb)
				
				;// ask for the new hostname for the printer
				if $newPrinterName <> "" Then
					GUICtrlSetData($lbl,"Enter the printer address for """ & $newPrinterName & """")
					GUICtrlSetData($cb,$oldPrinterHost)
					
					$state = 2
				EndIf
				
			case $state = 2
			
				$newPrinterHost = GUICtrlRead($cb)
			
				;// do the renaming here!
				If MsgBox(4,"Are you sure?","Do you want to rename """ & $oldPrinterName & """ to """ & $newPrinterName & """ at """ & $newPrinterHost & """?") = 6 Then
					RenamePrinter($oldPrinterName, $newPrinterName, $newPrinterHost, 1)
				EndIf

		EndSelect
	EndIf
    If $msg = $GUI_EVENT_CLOSE Then ExitLoop
Wend


Func RenamePrinter($oldPrinterName, $newPrinterName, $newPrinterHost, $interactive )

	;// stop spooler service first
	RunWait("cmd /c net stop spooler")
	
	$rename = 1
	
	;// see if new printer already exists, if it does, then don't change anything except the port
	$t_nPrint = GetPrinterKeyByName($newPrinterName)
	if $t_nPrint <> "" Then
		$newPrinterName = $t_nPrint
		$rename = 0
	EndIf
					
	$nPrint = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Print\Printers\" & $newPrinterName
	$nPrintL = "HKEY_LOCAL_MACHINE\" & $nPrint
	$oPrint = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Print\Printers\" & $oldPrinterName
	
	;// compare the keys
	If $rename And $nPrint <> $oPrint Then
	
		;// only do the copying if the names aren't the same
	
		$r1 = DllCall("advapi32.dll","int","RegCreateKeyEx","int",0x80000002,"str",$nPrint,"int",0,"int",0,"int",0,"int",0x3f,"int",0,"long_ptr",0,"long_ptr",0)	

		If @error <> 0 or $r1[8] = 0 Then
			MsgBox(0,"Error","Error creating key: " & @error)
			Exit
		EndIf
		
		$r2 = DllCall("shlwapi.dll","int","SHCopyKey","int",0x80000002,"str",$oPrint,"int",$r1[8],"int",0)
		$r3 = DllCall("shlwapi.dll","int","SHDeleteKey","int",0x80000002,"str",$oPrint)
		$r4 = DllCall("advapi32.dll","int","RegCloseKey","int",$r1[8])
	
		;// rename stuff in here
		RegWrite($nPrintL,"Name","REG_SZ",$newPrinterName)
		RegWrite($nPrintL & "\DsSpooler","printerName","REG_SZ",$newPrinterName)
		RegWrite($nPrintL & "\DsSpooler","uNCName","REG_SZ", "\\" & @ComputerName & "\\\" & $newPrinterName)
	
	EndIf
	
	
	
	;// rename ports
	if $newPrinterHost <> "" Then
		RegWrite($nPrintL,"Port","REG_SZ",$newPrinterHost)
		RegWrite($nPrintL & "\DsSpooler","portName","REG_SZ",$newPrinterHost)
		RegWrite($nPrintL & "\HttpData","UIRealNetworkName","REG_SZ",$newPrinterHost)
	EndIf
	
	;// restart spooler so changes take effect
	RunWait("cmd /c net start spooler")
	
	If $interactive Then MsgBox(0,"","Printer successfully renamed!")
	
	Exit

EndFunc

;// used for non-interactive mode, checks to see if a printer exists and returns its key if it does
;// otherwise, it returns nothing. 
Func GetPrinterKeyByName($key)

	$hKey = "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Print\Printers"

	For $i = 1 to 1000
		$var = RegEnumKey($hKey, $i)
		If @error <> 0 Then ExitLoop
	
		If $key = $var Then Return $var
		
		$name = RegRead($hKey & "\" & $var, "Name")
		
		If $name = $key Then Return $var
		
	Next

	Return ""
	
EndFunc

